# naceteme matematickou a numerickou knihovnu
import math
import numpy as np

# kolik bodu budeme generovat
pocet = 10000000
# pole (matice) nahodnych cisel od 0 do 1,
# ktera ma "pocet" radku a 6 sloupcu, pricemz kazdy
# radek predstavuje souradnice jendoho bodu v 6D prostoru
n = np.random.rand(pocet,6)
# inicializace promenne, do niz budeme ukladat pocet zasahu dovnitr koule
pocet_uvnitr = 0

# cyklus, ktery prochazi cisla od 0 do pocet-1
for i in range(0,pocet):
    # v hranate zavorce piseme radkovy a sloupcovy index oddeleny carkou,
    # pomoci Pythagorovy vety kontrolujeme, ze bod lezi v kouli
    if n[i,0]**2 + n[i,1]**2 + n[i,2]**2 + n[i,3]**2 + n[i,4]**2 + n[i,5]**2 < 1:
        # pokud je bod v kouli, zvysime pocet zasahu o jedna
        pocet_uvnitr += 1

# vypocet prumeru; ve jmenovateli je prictena nula, aby byl vysledek float
prumer = pocet_uvnitr/(pocet+0.)
# relativni odchylka od prumeru a relativni smerodatna odchylka
# math.pi vola hodnotu cisla pi
faktor = (math.pi)**3/math.factorial(3)/2.**6
odchylka = np.abs(prumer - faktor)/faktor
smodch = np.sqrt(faktor*(1. - faktor)/pocet)/faktor

# nechame vypsat vysledek na obrazovku
print("Prumer: {}, relativni smodch: {}, relativni odchylka od prumeru: {}.".format(prumer*2.**6, smodch, odchylka))
